#include "common.h"
#define NULL "(_null 0)"
#define HDR "(_hdr 0)"
#define FTR "(_ftr 0)"
#define PAIR(k,S2) "(" k " _pair " S2 ")"
#define APPEND(S1,S2) "(" S1 " _append " S2 ")"
#define DECODE(S) "(_decode " S ")"
#define ENCODE(start,end) "(" start " _encode " end ")"
#define FST(p) "(_fst " p ")"
#define SND(p) "(_snd " p ")"
#define GET(a,i) "(" a " _get " i ")"
#define SEL(D,i) "(" D " sel " i ")"

char *AXIOMS =
FORALL(QUANT3(k,s1,s2), \
	   NEQ(PAIR("k", ENCODE("s1","s2")), FTR), \
	   PATT1(PAIR("k", ENCODE("s1","s2")))) "; "
FORALL(QUANT5(f,X,k,s1,s2), \
	   IMPLIES(AND(EQ("f",FST("X")), EQ("X",PAIR("k",ENCODE("s1","s2")))), EQ("f","k")), \
	   PATT1(ANDPATT2(EQ("f",FST("X")), PAIR("k", ENCODE("s1","s2"))))) "; "
FORALL(QUANT6(x,d,ln,len,Array_D,start), \
	   IMPLIES(AND3(
	               LT("x","len"), \
				   EQ("d",DECODE(SND("ln"))), \
				   EQ("ln",PAIR("len",ENCODE(SEL("Array_D","start"),"len"))) \
			       ), \
			   EQ(GET("d","x"),SEL("Array_D",ADD("start","x")))), \
	   PATT1(ANDPATT3(GET("d","x"), \
				   EQ("d",DECODE(SND("ln"))), \
				   PAIR("len",ENCODE(SEL("Array_D","start"),"len")) \
			       ))) "; "
;