
void main() {
	char n;
	char *A,*B,*C;
	char i,j,r;

	IN(BOUND(A,0,n),n);
	ASSUME("(_n >= 0)");
	i=0; j=0;
	while (i<n) {
		r=1;
		while (i+1<n && A[i]==A[i+1]) {
			r++; i++;
		}
		A[j]=A[i]; C[j]=r;
		j++; i++;
	}
	OUT(A,C,j);
}

void inverted() {
	char *A_;
	char x,y,s;

	TS(y,x);
	while (GUARD()) {
		TS(s);
		while (GUARD()) {
			TS(y,s,A_);
		}
		TS(x);
	}
	OUT(BOUND(A_,0,y),y);
}

int params () {
	char* MODE = "invert"; 
	char* predicates = 
		"(_x < _j), "
		"(_s > 0), "
		"((_A_ sel _y) == (_A_ sel (_y + 1))), "
		;
	char* expressions = 
		"(0):int, (1):int, "
		"(_C sel _x):int, "
		// "(_A_ sel _y):int, " // easily eliminated by user
		// "(_C upd _x upd _s):int*, " // easily eliminated by user
		"(_A_ upd _y upd (_A sel _x)):int*, " // needed: midified by user from the one below
		// "(_A_ upd _y upd (_A_ sel _x)):int*, " // initially mined. The modification hints to the user are described in domain/inrl.notes
		"(_A_ upd _x upd (_A_ sel _y)):int*, " // redundant but added anyway
		"(_s + 1):int, (_s - 1):int, "
		"(_y + 1):int, (_y - 1):int, "
		"(_x + 1):int, (_x - 1):int, "
		;
	char *KINDS = "int; string; ";
	char *TYPES = "int* _A_; "; // the rest default to Int
	char *SYMS =
		"_BOUND:int->int->int->int; "
		;
	char* NOTES = 
		"ExpectedSolution : "
		" &&& "
		"Benchmark : rl";
}
